import React from 'react';
/**
 * @param { object } themeColor - Carousel Theme color, including prev/next buttons and scroll bar
 *  @param { string } themeColor.button - button color, hex color code
 *  @param { string } themeColor.buttonText - button Text Color, hex color code
 *  @param { string } themeColor.scrollBar - scrollbar color, hex color code
 * @param { object } [buttonText] - buttons text
 *  @param { boolean } [showButton = true] - whether show buttons
 *  @param { number } [buttonWidth = 20] - button width
 *  @param { number } [buttonHeight = 100] - button height
 *  @param { boolean } [buttonText.isImageBg = false] - whether take image as background, image size should be 40 x 100
 *  @param { string } [buttonText.prev = '<'] - prev button text / img src
 *  @param { string } [buttonText.next = '>'] - next button text / img src
 * @param { number } [componentHeight = 0] - height of the Carousel, if 0, height will set to auto,
 * @param { boolean } isDivElement - whether the children are div element
 * @param { array } [urlArray] - if not div elements, urlArray has to be set
 * @param { number } [interval] - interval between slides
 */
interface Props {
    isDivElement: boolean;
    urlArray?: {
        url: string;
        link?: string;
        isVideo?: boolean;
    }[];
    componentHeight?: number;
    themeColor: {
        button: string;
        buttonText: string;
        scrollBar: string;
    };
    buttonText?: {
        showButton: boolean;
        buttonWidth: number;
        buttonHeight: number;
        isImageBg: boolean;
        prev: string;
        next: string;
    };
    interval?: number;
    pauseCarousel?: number;
}
declare const CarouselFullWidth: React.FC<Props>;
export default CarouselFullWidth;
//# sourceMappingURL=CarouselFullWidth.d.ts.map