"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var lodash_1 = __importDefault(require("lodash"));
var SingleElement_1 = __importDefault(require("./SingleElement"));
// import debounce from '../lib/debounce';
var smoothScrollTo_1 = require("../lib/smoothScrollTo");
var CarouselFullWidth_style_1 = require("./CarouselFullWidth.style");
var Button_style_1 = require("./Button.style");
var customMediaQuery_1 = require("../lib/customMediaQuery");
var CarouselFullWidth = function (_a) {
    var _themeColor = _a.themeColor, _isDivElement = _a.isDivElement, _urlArray = _a.urlArray, _componentHeight = _a.componentHeight, _interval = _a.interval, _children = _a.children, _buttonText = _a.buttonText;
    var _b = react_1.default.useState(0), containerWidth = _b[0], setContainerWidth = _b[1];
    var _c = react_1.default.useState(0), currentSliderIndex = _c[0], setCurrentSliderIndex = _c[1];
    var containerRef = react_1.default.useRef(null);
    var imagesHolderRef = react_1.default.useRef(null);
    var _d = react_1.default.useState([]), itemsWidth = _d[0], setItemsWidth = _d[1];
    var _e = react_1.default.useState(0), itemAmount = _e[0], setItemAmount = _e[1];
    var _f = react_1.default.useState(false), isCarouselPaused = _f[0], setIsCarouselPaused = _f[1];
    var _g = react_1.default.useState([]), itemRefs = _g[0], setItemRefs = _g[1];
    var _h = react_1.default.useState(1), scrollDirection = _h[0], setScrollDirection = _h[1];
    var prevButtonRef = react_1.default.useRef(null);
    var nextButtonRef = react_1.default.useRef(null);
    var _j = react_1.default.useState([]), stepsLengthArr = _j[0], setStepsLengthArr = _j[1];
    var _k = react_1.default.useState(_themeColor), themeColor = _k[0], setThemeColor = _k[1];
    var _l = react_1.default.useState(_isDivElement), isDivElement = _l[0], setIsDivElement = _l[1];
    var _m = react_1.default.useState(_urlArray), urlArray = _m[0], setUrlArray = _m[1];
    var _o = react_1.default.useState(_componentHeight), componentHeight = _o[0], setComponentHeight = _o[1];
    var _p = react_1.default.useState(_interval), interval = _p[0], setThisInterval = _p[1];
    var _q = react_1.default.useState(_children), children = _q[0], setChildren = _q[1];
    var _r = react_1.default.useState(_buttonText), buttonText = _r[0], setButtonText = _r[1];
    // set new state when get new prop
    react_1.default.useEffect(function () {
        if (_themeColor !== undefined)
            setThemeColor(_themeColor);
        if (_isDivElement !== undefined)
            setIsDivElement(_isDivElement);
        if (_urlArray !== undefined)
            setUrlArray(_urlArray);
        if (_componentHeight !== undefined)
            setComponentHeight(_componentHeight);
        if (_interval !== undefined)
            setThisInterval(_interval);
        if (_children !== undefined)
            setChildren(_children);
        if (_buttonText !== undefined)
            setButtonText(_buttonText);
    }, [
        _themeColor,
        _isDivElement,
        _urlArray,
        _componentHeight,
        _interval,
        _children,
        _buttonText,
    ]);
    // DONE: adjust width when resize
    // NOTE: auto height module will work nicely when tablet or phone
    // handler drag move carousel
    react_1.default.useEffect(function () {
        if (imagesHolderRef.current !== null) {
            var holder_1 = imagesHolderRef.current;
            holder_1.style.cursor = 'grab';
            var pos_1 = { top: 0, left: 0, x: 0, y: 0 };
            var mouseDownHandler_1 = function (e) {
                e.stopPropagation();
                // console.log('Mouse down');
                holder_1.style.cursor = 'grabbing';
                holder_1.style.userSelect = 'none';
                holder_1.style.removeProperty('scroll-snap-type');
                holder_1.style.margin = '0'; // scroll snap will conflict with preset margin
                pos_1 = {
                    left: holder_1.scrollLeft,
                    top: holder_1.scrollTop,
                    x: e.clientX,
                    y: e.clientY,
                };
                holder_1.addEventListener('mousemove', mouseMoveHandler_1);
                holder_1.addEventListener('mouseup', mouseUpHandler_1);
            };
            var mouseMoveHandler_1 = function (e) {
                e.stopPropagation();
                // console.log('Mouse move');
                var dx = e.clientX - pos_1.x;
                var dy = e.clientY - pos_1.y;
                holder_1.scrollTop = pos_1.top - dy;
                holder_1.scrollLeft = pos_1.left - dx;
            };
            var mouseUpHandler_1 = function (e) {
                e.stopPropagation();
                // console.log('Mouse up');
                holder_1.style.cursor = 'grab';
                holder_1.style.removeProperty('user-select');
                holder_1.style['scroll-snap-type'] = 'x mandatory';
                // console.log(holder.scrollLeft);
                var stepsLengthArr = []; // these are the actual number to move
                var __position = 0;
                stepsLengthArr.push(__position);
                for (var i = 0; i < itemAmount - 1; i += 1) {
                    __position += itemsWidth[i];
                    stepsLengthArr.push(__position);
                }
                var __tempIndex = 0;
                for (var i = 0; i < stepsLengthArr.length; i += 1) {
                    if (holder_1 && holder_1.scrollLeft >= stepsLengthArr[i]) {
                        __tempIndex = i;
                    }
                }
                setCurrentSliderIndex(__tempIndex);
                holder_1.removeEventListener('mousemove', mouseMoveHandler_1);
                holder_1.removeEventListener('mouseup', mouseUpHandler_1);
            };
            holder_1.addEventListener('mousedown', mouseDownHandler_1);
            return function () {
                holder_1.removeEventListener('mousedown', mouseDownHandler_1);
                holder_1.removeEventListener('mousemove', mouseMoveHandler_1);
                holder_1.removeEventListener('mouseup', mouseUpHandler_1);
            };
        }
        return function () { };
    });
    // set container width
    react_1.default.useEffect(function () {
        if (containerRef.current) {
            setContainerWidth(Number(containerRef.current.offsetWidth.toString().replace('px', '')));
        }
        else {
            // do nothing
        }
    }, [urlArray]);
    var resizeHandler = lodash_1.default.debounce(function () {
        var __containerWidth = containerRef.current
            ? Number(containerRef.current.offsetWidth.toString().replace('px', ''))
            : 0;
        setContainerWidth(__containerWidth);
        // console.log(__containerWidth);
    }, 500);
    // set containerWidth on window resize
    react_1.default.useEffect(function () {
        // DONE: set containerWidth on window resize
        // //Don't apply [] to this useEffect, otherwise offsetWidth will not equal to the real width after first render
        // https://stackoverflow.com/questions/53949393/cant-perform-a-react-state-update-on-an-unmounted-component
        // solve Can't perform a React state update on an unmounted component
        // let isMounted = true;
        var _containerWidth = containerRef.current
            ? Number(containerRef.current.offsetWidth.toString().replace('px', ''))
            : 0;
        setContainerWidth(_containerWidth);
        window.addEventListener('resize', resizeHandler);
        return function () {
            // isMounted = false;
            window.removeEventListener('resize', resizeHandler);
        };
    }, []);
    // set item amount
    react_1.default.useEffect(function () {
        if (!isDivElement && urlArray) {
            setItemAmount(urlArray === null || urlArray === void 0 ? void 0 : urlArray.length);
        }
        else if (isDivElement) {
            setItemAmount(react_1.default.Children.count(children));
        }
    }, [isDivElement, urlArray, children]);
    // init item refs
    react_1.default.useEffect(function () {
        setItemRefs(function (itemRefs) {
            return Array(itemAmount)
                .fill(0)
                .map(function (_, i) {
                return itemRefs[i] || react_1.default.createRef();
            });
        });
    }, [itemAmount]);
    // get all items width
    react_1.default.useEffect(function () {
        var __itemsWidth = Array(itemAmount).fill(containerWidth);
        setItemsWidth(__itemsWidth);
    }, [containerWidth, itemAmount, itemRefs]);
    // auto increase slider index
    react_1.default.useEffect(function () {
        var auto_interval = interval || 2000; // interval
        // if is paused then pause
        // if is not paused, auto increase current slide index by 1 until reach the end then go back to 0
        var nIntervalId = setInterval(function () {
            if (isCarouselPaused) {
                // pause carousel
                // console.log('paused');
            }
            else if (currentSliderIndex === itemAmount - 1) {
                //  right end
                // setCurrentSliderIndex(0);
                setScrollDirection(-1);
                setCurrentSliderIndex(currentSliderIndex - 1);
            }
            else if (currentSliderIndex === 0) {
                // left end
                setCurrentSliderIndex(currentSliderIndex + 1);
                if (scrollDirection === -1)
                    setScrollDirection(1);
            }
            else {
                // middle
                setCurrentSliderIndex(currentSliderIndex + scrollDirection * 1);
            }
            // DONE: when reach the end, instead of going to 0, go back 1 per step until 0 then go forward by 1 a time
            /**
             * 1. left end
             *    1. d = 1 => index + 1
             *    2. d = -1 => d = 1, index +1
             * 2. middle
             *    1. d = 1 => index + 1
             *    2. d = -1 => index - 1
             * 3. right end
             *    1. d = 1 => d = -1, index - 1
             *    2. (in theory but don't exit in reality) d = -1 => d = 1, index - 1
             */
        }, auto_interval);
        return function () { return clearInterval(nIntervalId); };
    }, [
        currentSliderIndex,
        isCarouselPaused,
        itemAmount,
        interval,
        scrollDirection,
    ]);
    // set stepsLengthArr
    react_1.default.useEffect(function () {
        var _stepsLengthArr = []; // these are the actual number to move
        var __position = 0;
        _stepsLengthArr.push(__position);
        for (var i = 0; i < itemAmount - 1; i += 1) {
            __position += itemsWidth[i]; // __position is accumulated number not for each slide
            _stepsLengthArr.push(__position);
        }
        setStepsLengthArr(_stepsLengthArr);
    }, [containerWidth, itemAmount, itemsWidth]);
    // move the slide automatically or by clicking the buttons. Not swap or drag
    react_1.default.useEffect(function () {
        // DONE: smooth swipe
        // take the current slide index and display it
        var holder = imagesHolderRef.current;
        var currentPosition = 0; // the number to set scrollLeft
        /**
         * NOTE: only full width carousel has auto scroll feature,
         */
        currentPosition = stepsLengthArr[currentSliderIndex];
        if (holder && !isCarouselPaused) {
            // console.log(stepsLengthArr);
            holder.style['scroll-snap-type'] = 'none';
            smoothScrollTo_1.scrollTo.left(holder, holder.scrollLeft, currentPosition, 500);
        }
    }, [
        containerWidth,
        itemsWidth,
        currentSliderIndex,
        itemAmount,
        isCarouselPaused,
        stepsLengthArr,
    ]);
    // pause auto movement when tag lose focus
    react_1.default.useEffect(function () {
        var visibilityHandler = function () {
            if (document.visibilityState === 'visible') {
                // console.log("focus");
                setIsCarouselPaused(false);
            }
            else {
                // console.log("blur");
                setIsCarouselPaused(true);
            }
        };
        window.addEventListener('visibilitychange', visibilityHandler);
        return function () {
            window.removeEventListener('visibilitychange', visibilityHandler);
        };
    });
    var mouseEnterHandler = function () {
        setIsCarouselPaused(true);
        // DONE: hide buttons when tablet
        var mql = window.matchMedia("(max-width: " + customMediaQuery_1.tabletDelimiter + "px)");
        if (mql.matches)
            return;
        if (prevButtonRef.current && nextButtonRef.current) {
            prevButtonRef.current.style.display = 'grid';
            nextButtonRef.current.style.display = 'grid';
        }
    };
    var mouseLeaveHandler = function () {
        setIsCarouselPaused(false);
        if (prevButtonRef.current && nextButtonRef.current) {
            prevButtonRef.current.style.display = 'none';
            nextButtonRef.current.style.display = 'none';
        }
    };
    // set prev next buttons listeners
    react_1.default.useEffect(function () {
        if (prevButtonRef.current &&
            nextButtonRef.current &&
            imagesHolderRef.current) {
            var prevButton_1 = prevButtonRef.current;
            var nextButton_1 = nextButtonRef.current;
            var holder_2 = imagesHolderRef.current;
            var currentPosition_1 = 0;
            var prevMouseDownHandler_1 = function (e) {
                e.stopPropagation();
                if (currentSliderIndex === 0) {
                    // do nothing
                }
                else {
                    currentPosition_1 = stepsLengthArr[currentSliderIndex - 1];
                    holder_2.style['scroll-snap-type'] = 'none';
                    smoothScrollTo_1.scrollTo.left(holder_2, holder_2.scrollLeft, currentPosition_1, 500);
                    setCurrentSliderIndex(currentSliderIndex - 1);
                }
                prevButton_1.addEventListener('mouseup', prevMouseUpHandler_1);
            };
            var prevMouseUpHandler_1 = function () {
                // setIsCarouselPaused(true);
                prevButton_1.removeEventListener('mouseup', prevMouseUpHandler_1);
            };
            var nextMouseDownHandler_1 = function (e) {
                e.stopPropagation();
                if (currentSliderIndex === itemAmount - 1) {
                    // do nothing
                }
                else {
                    // console.log('down handler => currentSliderIndex: '+currentSliderIndex);
                    currentPosition_1 = stepsLengthArr[currentSliderIndex + 1];
                    holder_2.style['scroll-snap-type'] = 'none';
                    smoothScrollTo_1.scrollTo.left(holder_2, holder_2.scrollLeft, currentPosition_1, 500);
                    setCurrentSliderIndex(currentSliderIndex + 1);
                }
                nextButton_1.addEventListener('mouseup', nextMouseUpHandler_1);
            };
            var nextMouseUpHandler_1 = function () {
                // setIsCarouselPaused(true);
                // console.log('up handler => currentSliderIndex: '+currentSliderIndex);
                nextButton_1.removeEventListener('mouseup', nextMouseUpHandler_1);
            };
            prevButton_1.addEventListener('mousedown', prevMouseDownHandler_1);
            nextButton_1.addEventListener('mousedown', nextMouseDownHandler_1);
            return function () {
                prevButton_1.removeEventListener('mousedown', prevMouseDownHandler_1);
                nextButton_1.removeEventListener('mousedown', nextMouseDownHandler_1);
                prevButton_1.removeEventListener('mouseup', nextMouseUpHandler_1);
                nextButton_1.removeEventListener('mouseup', nextMouseUpHandler_1);
            };
        }
        return function () { };
    }, [currentSliderIndex, itemAmount, stepsLengthArr]);
    // when reaching ends disable buttons
    react_1.default.useEffect(function () {
        if (prevButtonRef.current && nextButtonRef.current) {
            var prevButton = prevButtonRef.current;
            var nextButton = nextButtonRef.current;
            if (currentSliderIndex === 0) {
                // left end, disable prev
                prevButton.style.filter = 'grayscale(1)';
                prevButton.style.cursor = 'not-allowed';
            }
            else if (currentSliderIndex === itemAmount - 1) {
                // right end, disable next
                nextButton.style.filter = 'grayscale(1)';
                nextButton.style.cursor = 'not-allowed';
            }
            else {
                prevButton.style.filter = 'none';
                nextButton.style.filter = 'none';
                prevButton.style.cursor = 'pointer';
                nextButton.style.cursor = 'pointer';
            }
        }
    });
    // React.useEffect(() => { //for development purpose
    //   const auto_interval = interval ? interval : 2000; //interval
    //   if(pauseCarousel) {
    //     setCurrentSliderIndex(pauseCarousel);
    //     const nIntervalId = setInterval(() => {
    //       setIsCarouselPaused(true);
    //     }, auto_interval);
    //     return () => clearInterval(nIntervalId);
    //   }
    // }, []);
    var buttonContent = function (param) {
        var tempBtn = {
            prev: '<',
            next: '>',
        };
        if (buttonText) {
            if (buttonText.isImageBg && buttonText[param].length >= 4) {
                return react_1.default.createElement("img", { src: buttonText[param], alt: param });
            }
            return tempBtn[param];
        }
        return tempBtn[param];
    };
    var setColor = function (param) {
        var tempColor = {
            buttonText: '#fff',
            button: '#961c1c',
            scrollBar: 'darkgrey',
        };
        if (themeColor && themeColor[param]) {
            if (/^#([0-9A-F]{3}){1,2}$/i.test(themeColor[param])) {
                // valid hex color
                return themeColor[param];
            }
            console.error("themeColor." + param + " need to be valid hex color code");
            return tempColor[param];
        }
        return tempColor[param];
    };
    if (urlArray) {
        return (react_1.default.createElement(CarouselFullWidth_style_1.Styled.Container, { ref: containerRef, onMouseEnter: function () { return mouseEnterHandler(); }, onMouseLeave: function () { return mouseLeaveHandler(); } },
            (buttonText === null || buttonText === void 0 ? void 0 : buttonText.showButton) ? (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(Button_style_1.Button.Prev, { ref: prevButtonRef, imageButton: (buttonText === null || buttonText === void 0 ? void 0 : buttonText.isImageBg) ? buttonText.isImageBg : false, colorTxt: setColor('buttonText'), colorBg: setColor('button'), buttonWidth: buttonText ? buttonText.buttonWidth : 20, buttonHeight: buttonText ? buttonText.buttonHeight : 100 }, buttonContent('prev')),
                react_1.default.createElement(Button_style_1.Button.Next, { ref: nextButtonRef, imageButton: (buttonText === null || buttonText === void 0 ? void 0 : buttonText.isImageBg) ? buttonText.isImageBg : false, colorTxt: setColor('buttonText'), colorBg: setColor('button'), buttonWidth: buttonText ? buttonText.buttonWidth : 20, buttonHeight: buttonText ? buttonText.buttonHeight : 100 }, buttonContent('next')))) : (react_1.default.createElement(react_1.default.Fragment, null)),
            react_1.default.createElement(CarouselFullWidth_style_1.Styled.ImagesHolder, { ref: imagesHolderRef, colorScrollbar: setColor('scrollBar') }, urlArray.map(function (x, index) {
                return (react_1.default.createElement(SingleElement_1.default, { isDivElement: isDivElement, isImageElement: true, isVideoElement: x.isVideo ? x.isVideo : false, isFullWidthElement: true, url: x.url, link: x.link, imgAlt: "", gap: 0, height: componentHeight, roundCorner: 0, key: index, _ref: itemRefs[index] }));
            }))));
    }
    return (react_1.default.createElement(CarouselFullWidth_style_1.Styled.Container, { ref: containerRef, onMouseEnter: function () { return mouseEnterHandler(); }, onMouseLeave: function () { return mouseLeaveHandler(); } },
        (buttonText === null || buttonText === void 0 ? void 0 : buttonText.showButton) ? (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(Button_style_1.Button.Prev, { ref: prevButtonRef, imageButton: (buttonText === null || buttonText === void 0 ? void 0 : buttonText.isImageBg) ? buttonText.isImageBg : false, colorTxt: setColor('buttonText'), colorBg: setColor('button'), buttonWidth: buttonText ? buttonText.buttonWidth : 20, buttonHeight: buttonText ? buttonText.buttonHeight : 100 }, buttonContent('prev')),
            react_1.default.createElement(Button_style_1.Button.Next, { ref: nextButtonRef, imageButton: (buttonText === null || buttonText === void 0 ? void 0 : buttonText.isImageBg) ? buttonText.isImageBg : false, colorTxt: setColor('buttonText'), colorBg: setColor('button'), buttonWidth: buttonText ? buttonText.buttonWidth : 20, buttonHeight: buttonText ? buttonText.buttonHeight : 100 }, buttonContent('next')))) : (react_1.default.createElement(react_1.default.Fragment, null)),
        react_1.default.createElement(CarouselFullWidth_style_1.Styled.ImagesHolder, { ref: imagesHolderRef, colorScrollbar: setColor('scrollBar') }, isDivElement && children
            ? react_1.default.Children.map(children, function (child, index) {
                return (react_1.default.createElement(SingleElement_1.default, { isDivElement: isDivElement, isVideoElement: false, isImageElement: false, isFullWidthElement: true, gap: 0, height: componentHeight, minWidth: 0, roundCorner: 0, _ref: itemRefs[index] }, child));
            })
            : 'Please set urlArray or children')));
};
exports.default = CarouselFullWidth;
//# sourceMappingURL=CarouselFullWidth.js.map