import React from 'react';
/**
 * @param { object } themeColor - Carousel Theme color, including prev/next buttons and scroll bar
 *  @param { string } themeColor.reminder - reminder color
 *  @param { string } themeColor.reminderTxt - reminder Text Color
 * @param { object } [reminder] - both ends reminder
 *  @param { boolean } [showReminder = true] - whether to show reminder
 *  @param { string } [reminder.firstTxt = 'First One'] - text on the reminder for first one, default first one
 *  @param { string } [reminder.lastTxt = 'Last One'] - text on the reminder for last one, default last one
 * @param { boolean } [componentHeight = 'auto'] - height of the Carousel,
 * @param { object } [buttonText] - buttons text
 *  @param { boolean } [showButton = true] - whether show buttons
 *  @param { number } [buttonWidth = 20] - button width
 *  @param { number } [buttonHeight = 100] - button height
 *  @param { boolean } [buttonText.isImageBg = false] - whether take image as background, image size should be 40 x 100
 *  @param { string } [buttonText.prev = '<'] - prev button text / img src
 *  @param { string } [buttonText.next = '>'] - next button text / img src
 * @param { number } gap - space between children
 * @param { number } [roundCorner = 0] - round corner of child element
 * @param { boolean } isDivElement - if the children are div element
 * @param { array } [urlArray] - if not div elements, urlArray has to be set
 * @param { number } [divElementMinWidth] - if div element, need to set divElementMinWidth
 */
interface Props {
    themeColor: {
        reminder: string;
        reminderTxt: string;
    };
    reminder: {
        showReminder: boolean;
        firstTxt: string;
        lastTxt: string;
    };
    buttonText?: {
        showButton: boolean;
        buttonWidth: number;
        buttonHeight: number;
        isImageBg: boolean;
        prev: string;
        next: string;
    };
    componentHeight?: number;
    gap: number;
    roundCorner?: number;
    isDivElement: boolean;
    urlArray?: {
        url: string;
        link?: string;
        isVideo?: boolean;
    }[];
    divElementMinWidth?: number;
}
/**
 * when imageHolder is shorter than container
 * e.g.: only have one slide, but the container is ready to show 2
 * solution: imageHolder occupy 100%, hold the elements as normal
 *
 */
declare const CarouselQueue: React.FC<Props>;
export default CarouselQueue;
//# sourceMappingURL=CarouselQueue.d.ts.map