"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable no-else-return */
var react_1 = __importDefault(require("react"));
var lodash_1 = __importDefault(require("lodash"));
var SingleElement_1 = __importDefault(require("./SingleElement"));
// import debounce from '../lib/debounce';
// import { scrollTo } from '../lib/smoothScrollTo';
var CarouselQueue_style_1 = require("./CarouselQueue.style");
var Button_style_1 = require("./Button.style");
var customMediaQuery_1 = require("../lib/customMediaQuery");
// TODO: fixed amount children(not exactly!!!)
/**
 * when imageHolder is shorter than container
 * e.g.: only have one slide, but the container is ready to show 2
 * solution: imageHolder occupy 100%, hold the elements as normal
 *
 */
var CarouselQueue = function (props) {
    // const [containerWidth, setContainerWidth] = React.useState<number>(0);
    // const [currentSliderIndex, setCurrentSliderIndex] = React.useState<number>(0);
    var _a = react_1.default.useState({
        position: 'left-end',
    }), carouselPosition = _a[0], setCarouselPosition = _a[1];
    var containerRef = react_1.default.useRef(null);
    var imagesHolderRef = react_1.default.useRef(null);
    var imagesHolderBeforeRef = react_1.default.useRef(null);
    var imagesHolderAfterRef = react_1.default.useRef(null);
    var _b = react_1.default.useState(false), imageHolderBeforeVisibility = _b[0], setImageHolderBeforeVisibility = _b[1];
    var _c = react_1.default.useState(false), imageHolderAfterVisibility = _c[0], setImageHolderAfterVisibility = _c[1];
    var prevButtonRef = react_1.default.useRef(null);
    var nextButtonRef = react_1.default.useRef(null);
    // const [slideRefs, setSlideRefs] = React.useState<
    //   Array<(ele: HTMLElement) => void>
    // >([]);
    var _d = react_1.default.useState(), slidesPosition = _d[0], setSlidesPosition = _d[1];
    var _e = react_1.default.useState(0), currentFirstIndex = _e[0], setCurrentFirstIndex = _e[1];
    var _f = react_1.default.useState(0), holderScrollLeft = _f[0], setHolderScrollLeft = _f[1];
    var themeColor = props.themeColor, reminder = props.reminder, buttonText = props.buttonText, componentHeight = props.componentHeight, gap = props.gap, roundCorner = props.roundCorner, isDivElement = props.isDivElement, urlArray = props.urlArray, divElementMinWidth = props.divElementMinWidth, children = props.children;
    var _g = react_1.default.useState(urlArray || [{ url: '', link: '', isVideo: false }]), thisUrlArray = _g[0], setThisUrlArray = _g[1];
    var _h = react_1.default.useState(themeColor || { reminder: '', reminderTxt: '' }), thisThemeColor = _h[0], setThisThemeColor = _h[1];
    var _j = react_1.default.useState(reminder || {
        showReminder: true,
        firstTxt: 'First One',
        lastTxt: 'Last One',
    }), thisReminder = _j[0], setThisReminder = _j[1];
    var _k = react_1.default.useState(buttonText || {
        showButton: false,
        buttonWidth: 20,
        buttonHeight: 40,
        isImageBg: false,
        prev: '<',
        next: '>',
    }), thisButtonText = _k[0], setThisButtonText = _k[1];
    var _l = react_1.default.useState(componentHeight || 0), thisComponentHeight = _l[0], setThisComponentHeight = _l[1];
    var _m = react_1.default.useState(gap), thisGap = _m[0], setThisGap = _m[1];
    var _o = react_1.default.useState(roundCorner || 12), thisRoundCorner = _o[0], setThisRoundCorner = _o[1];
    var _p = react_1.default.useState(isDivElement || false), thisIsDivElement = _p[0], setThisIsDivElement = _p[1];
    var _q = react_1.default.useState(divElementMinWidth || 200), thisDivElementMinWidth = _q[0], setThisDivElementMinWidth = _q[1];
    var _r = react_1.default.useState(children), thisChildren = _r[0], setThisChildren = _r[1];
    // const [slidesBoundingInfo, setSlidesBoundingInfo] = React.useState({});
    // set new state when get new prop
    react_1.default.useEffect(function () {
        if (props.urlArray !== undefined)
            setThisUrlArray(props.urlArray);
        if (props.themeColor !== undefined)
            setThisThemeColor(props.themeColor);
        if (props.reminder !== undefined)
            setThisReminder(props.reminder);
        if (props.buttonText !== undefined)
            setThisButtonText(props.buttonText);
        if (props.componentHeight !== undefined)
            setThisComponentHeight(props.componentHeight);
        if (props.gap !== undefined)
            setThisGap(props.gap);
        if (props.roundCorner !== undefined)
            setThisRoundCorner(props.roundCorner);
        if (props.isDivElement !== undefined)
            setThisIsDivElement(props.isDivElement);
        if (props.divElementMinWidth !== undefined)
            setThisDivElementMinWidth(props.divElementMinWidth);
        if (props.children !== undefined)
            setThisChildren(props.children);
    }, [props]);
    // handler drag move carousel
    react_1.default.useEffect(function () {
        if (imagesHolderRef.current !== null) {
            var holder_1 = imagesHolderRef.current;
            holder_1.style.cursor = 'grab';
            var pos_1 = { top: 0, left: 0, x: 0, y: 0 };
            var mouseDownHandler_1 = function (e) {
                e.stopPropagation();
                // console.log('Mouse down');
                holder_1.style.cursor = 'grabbing';
                holder_1.style.userSelect = 'none';
                holder_1.style.removeProperty('scroll-snap-type');
                holder_1.style.margin = '0'; // scroll snap will conflict with preset margin
                pos_1 = {
                    left: holder_1.scrollLeft,
                    top: holder_1.scrollTop,
                    x: e.clientX,
                    y: e.clientY,
                };
                holder_1.addEventListener('mousemove', mouseMoveHandler_1);
                holder_1.addEventListener('mouseup', mouseUpHandler_1);
            };
            var mouseMoveHandler_1 = function (e) {
                e.stopPropagation();
                // console.log('Mouse move');
                var dx = e.clientX - pos_1.x;
                var dy = e.clientY - pos_1.y;
                holder_1.scrollTop = pos_1.top - dy;
                holder_1.scrollLeft = pos_1.left - dx;
            };
            var mouseUpHandler_1 = function (e) {
                e.stopPropagation();
                // console.log('Mouse up');
                holder_1.style.cursor = 'grab';
                holder_1.style.removeProperty('user-select');
                holder_1.style['scroll-snap-type'] = 'x mandatory';
                // console.log('ScrollLeft: '+holder.scrollLeft);
                // console.log('width: '+holder.offsetWidth);
                // console.log('ScrollWidth: '+holder.scrollWidth);
                if (holder_1.scrollWidth - holder_1.offsetWidth <= holder_1.scrollLeft) {
                    setCarouselPosition({ position: 'right-end' });
                }
                else if (holder_1.scrollLeft <= thisGap) {
                    setCarouselPosition({ position: 'left-end' });
                }
                else {
                    setCarouselPosition({ position: 'middle' });
                }
                setHolderScrollLeft(holder_1.scrollLeft);
                var _tempIndexArray = slidesPosition === null || slidesPosition === void 0 ? void 0 : slidesPosition.map(function (x, index) {
                    if (x[0] === holder_1.scrollLeft) {
                        return index;
                    }
                    if (index === 0 && holder_1.scrollLeft === 0) {
                        return 0;
                    }
                    return null;
                }).filter(function (x) { return x !== null; });
                var _currentFirstIndex = _tempIndexArray ? _tempIndexArray[0] : 0;
                if (_currentFirstIndex)
                    setCurrentFirstIndex(_currentFirstIndex);
                holder_1.removeEventListener('mousemove', mouseMoveHandler_1);
                holder_1.removeEventListener('mouseup', mouseUpHandler_1);
            };
            holder_1.addEventListener('mousedown', mouseDownHandler_1);
            return function () {
                holder_1.removeEventListener('mousedown', mouseDownHandler_1);
                holder_1.removeEventListener('mousemove', mouseMoveHandler_1);
                holder_1.removeEventListener('mouseup', mouseUpHandler_1);
            };
        }
        else {
            return function () { };
        }
    }, [slidesPosition]);
    // both end reminder
    react_1.default.useEffect(function () {
        var _before = imagesHolderBeforeRef.current;
        var _after = imagesHolderAfterRef.current;
        // console.log('ScrollLeft: '+holder.scrollLeft);
        // console.log('width: '+holder.offsetWidth);
        // console.log('ScrollWidth: '+holder.scrollWidth);
        if (_before && _after) {
            if (carouselPosition.position === 'left-end') {
                setImageHolderBeforeVisibility(true);
                setTimeout(function () {
                    setImageHolderBeforeVisibility(false);
                }, 2000);
            }
            else if (carouselPosition.position === 'right-end') {
                setImageHolderAfterVisibility(true);
                setTimeout(function () {
                    setImageHolderAfterVisibility(false);
                }, 2000);
            }
            else {
                setImageHolderAfterVisibility(false);
                setImageHolderBeforeVisibility(false);
            }
        }
    }, [carouselPosition]);
    // when reaching ends disable buttons
    react_1.default.useEffect(function () {
        if (prevButtonRef.current && nextButtonRef.current) {
            var prevButton = prevButtonRef.current;
            var nextButton = nextButtonRef.current;
            if (carouselPosition.position === 'left-end') {
                // left end, disable prev
                prevButton.style.filter = 'grayscale(1)';
                prevButton.style.cursor = 'not-allowed';
            }
            else if (carouselPosition.position === 'right-end') {
                // right end, disable next
                nextButton.style.filter = 'grayscale(1)';
                nextButton.style.cursor = 'not-allowed';
            }
            else {
                prevButton.style.filter = 'none';
                nextButton.style.filter = 'none';
                prevButton.style.cursor = 'pointer';
                nextButton.style.cursor = 'pointer';
            }
        }
    }, [carouselPosition]);
    // initialize callback refs
    // measure children with callback refs
    var _tempLength = 0;
    if (thisUrlArray[0].url) {
        // thisUrlArray has a default value {url:"",link:"", isVideo:false}
        _tempLength = thisUrlArray.length;
    }
    else if (react_1.default.Children) {
        _tempLength = react_1.default.Children.toArray(thisChildren).length;
    }
    var slidesBoundingInfo = {};
    var offsetLeftWidthInfo = {};
    // console.dir(thisUrlArray);
    var callbackRefsArray = Array(_tempLength)
        .fill(0)
        .map(function (_, i) {
        // console.dir('This is a callback ref');
        return function (ele) {
            var _a, _b;
            var thisIndex = i;
            if (ele) {
                // console.dir(ele);
                // console.dir(ele.offsetLeft);
                offsetLeftWidthInfo = __assign(__assign({}, offsetLeftWidthInfo), (_a = {}, _a[thisIndex] = [ele.offsetLeft, ele.offsetWidth], _a));
                slidesBoundingInfo = __assign(__assign({}, slidesBoundingInfo), (_b = {}, _b[thisIndex] = ele.getBoundingClientRect(), _b));
                // console.log(`Number ${thisIndex} is added!`);
            }
        };
    });
    // console.dir(callbackRefsArray);
    react_1.default.useEffect(function () {
        var _tempSlidesPosition = Array(Object.keys(offsetLeftWidthInfo).length)
            .fill([0, 0])
            .map(function (_, index) {
            return [offsetLeftWidthInfo[index][0], offsetLeftWidthInfo[index][1]];
        });
        // console.dir(_tempSlidesPosition);
        setSlidesPosition(_tempSlidesPosition);
    }, [thisUrlArray]);
    var resizeHandler = lodash_1.default.debounce(function () {
        // setSlidesPosition(getSlidesPosition());
        var _tempSlidesPosition = Array(Object.keys(offsetLeftWidthInfo).length)
            .fill([0, 0])
            .map(function (_, index) {
            return [offsetLeftWidthInfo[index][0], offsetLeftWidthInfo[index][1]];
        });
        // console.dir(_tempSlidesPosition);
        setSlidesPosition(_tempSlidesPosition);
    }, 500);
    // set slidesPosition on window resize
    react_1.default.useEffect(function () {
        // set containerWidth on window resize
        // Don't apply [] to this useEffect, otherwise offsetWidth will not equal to the real width after first render
        window.addEventListener('resize', resizeHandler);
        return function () {
            window.removeEventListener('resize', resizeHandler);
        };
    }, []);
    // get current first card's index
    react_1.default.useEffect(function () {
        var _tempIndexArray = slidesPosition === null || slidesPosition === void 0 ? void 0 : slidesPosition.map(function (x, index) {
            if (x[0] === holderScrollLeft) {
                return index;
            }
            if (index === 0 && holderScrollLeft === 0) {
                return 0;
            }
            return null;
        }).filter(function (x) { return x !== null; });
        var _currentFirstIndex = _tempIndexArray ? _tempIndexArray[0] : 0;
        if (_currentFirstIndex)
            setCurrentFirstIndex(_currentFirstIndex);
    }, []);
    // set holder scroll left base on index
    react_1.default.useEffect(function () {
        var _tempSlidesPosition = Array(Object.keys(offsetLeftWidthInfo).length)
            .fill([0, 0])
            .map(function (_, index) {
            return [offsetLeftWidthInfo[index][0], offsetLeftWidthInfo[index][1]];
        });
        var holder = imagesHolderRef.current;
        // console.dir(_tempSlidesPosition);
        if (_tempSlidesPosition &&
            _tempSlidesPosition[currentFirstIndex] &&
            holder) {
            var targetScrollLeft = _tempSlidesPosition[currentFirstIndex][0];
            if (typeof targetScrollLeft !== 'undefined')
                holder.scrollLeft = targetScrollLeft;
            // console.log(targetScrollLeft);
            setHolderScrollLeft(holder.scrollLeft);
        }
        // console.log('set holder scroll left base on index');
    }, [currentFirstIndex]);
    // handle prev button
    react_1.default.useEffect(function () {
        if (prevButtonRef.current !== null && imagesHolderRef.current !== null) {
            var prevButton_1 = prevButtonRef.current;
            var holder_2 = imagesHolderRef.current;
            var mouseDownHandler_2 = function (e) {
                e.stopPropagation();
                // console.log(holder.scrollLeft);
                var _currentFirstIndex = currentFirstIndex;
                if (holder_2.scrollWidth - holder_2.offsetWidth <= holder_2.scrollLeft) {
                    setCarouselPosition({ position: 'right-end' });
                    // keep moving
                    _currentFirstIndex -= 1;
                }
                else if (holder_2.scrollLeft === 0) {
                    setCarouselPosition({ position: 'left-end' });
                    // reaching left end, do nothing
                }
                else {
                    setCarouselPosition({ position: 'middle' });
                    // keep moving
                    // console.log('keep moving');
                    _currentFirstIndex -= 1;
                    // if (_currentFirstIndex === 0)
                    //   setCarouselPosition({ position: 'left-end' });
                }
                // console.log(`afterCLick index: ${_currentFirstIndex}`);
                setCurrentFirstIndex(_currentFirstIndex);
            };
            prevButton_1.addEventListener('mousedown', mouseDownHandler_2);
            return function () {
                prevButton_1.removeEventListener('mousedown', mouseDownHandler_2);
            };
        }
        else {
            return function () { };
        }
    }, [slidesPosition, currentFirstIndex]);
    // handle next button
    react_1.default.useEffect(function () {
        if (nextButtonRef.current !== null && imagesHolderRef.current !== null) {
            var nextButton_1 = nextButtonRef.current;
            var holder_3 = imagesHolderRef.current;
            var clickHandler_1 = function (e) {
                e.stopPropagation();
                // console.log(`currentFirstIndex: ${currentFirstIndex}`);
                var _currentFirstIndex = currentFirstIndex;
                if (holder_3.scrollLeft >= holder_3.scrollWidth - holder_3.offsetWidth) {
                    setCarouselPosition({ position: 'right-end' });
                    // reaching right end, do nothing
                    // console.dir('right-end');
                }
                else if (_currentFirstIndex === 0) {
                    // keep moving
                    _currentFirstIndex += 1;
                    setCarouselPosition({ position: 'middle' });
                }
                else {
                    // console.dir('middle');
                    setCarouselPosition({ position: 'middle' });
                    // keep moving
                    _currentFirstIndex += 1;
                }
                // console.log(`_currentFirstIndex: ${_currentFirstIndex}`);
                setCurrentFirstIndex(_currentFirstIndex);
            };
            nextButton_1.addEventListener('click', clickHandler_1);
            return function () {
                nextButton_1.removeEventListener('click', clickHandler_1);
            };
        }
        else {
            return function () { };
        }
    }, [slidesPosition, currentFirstIndex]);
    // DONE: disable buttons when imageHolder is shorter than container
    react_1.default.useEffect(function () {
        var _a;
        var _tempSlidesPosition = Array(Object.keys(offsetLeftWidthInfo).length)
            .fill([0, 0])
            .map(function (_, index) {
            return [offsetLeftWidthInfo[index][0], offsetLeftWidthInfo[index][1]];
        });
        var contentLength = 0;
        _tempSlidesPosition.map(function (x) {
            contentLength = contentLength + thisGap + x[1];
            return react_1.default.createElement(react_1.default.Fragment, null);
        });
        // console.dir(_tempSlidesPosition);
        // console.dir(imagesHolderRef.current?.offsetWidth);
        // console.dir(contentLength);
        var containerLength = (_a = imagesHolderRef.current) === null || _a === void 0 ? void 0 : _a.offsetWidth;
        if (containerLength && contentLength < containerLength) {
            // console.log('triggered function to hide buttons');
            setThisButtonText(__assign(__assign({}, thisButtonText), { showButton: false }));
        }
    }, []);
    var mouseEnterHandler = function () {
        // DONE: hide buttons when tablet
        var mql = window.matchMedia("(max-width: " + customMediaQuery_1.tabletDelimiter + "px)");
        if (mql.matches)
            return;
        if (prevButtonRef.current && nextButtonRef.current) {
            prevButtonRef.current.style.display = 'grid';
            nextButtonRef.current.style.display = 'grid';
        }
    };
    var mouseLeaveHandler = function () {
        if (prevButtonRef.current && nextButtonRef.current) {
            prevButtonRef.current.style.display = 'none';
            nextButtonRef.current.style.display = 'none';
        }
    };
    var buttonContent = function (param) {
        var tempBtn = {
            prev: '<',
            next: '>',
        };
        if (thisButtonText) {
            if (thisButtonText.isImageBg && thisButtonText[param].length >= 4) {
                return react_1.default.createElement("img", { src: thisButtonText[param], alt: param });
            }
            return tempBtn[param];
        }
        return tempBtn[param];
    };
    var setColor = function (param) {
        var tempColor = {
            reminder: '#000000',
            reminderTxt: '#fff',
        };
        if (thisThemeColor && thisThemeColor[param]) {
            if (/^#([0-9A-F]{3}){1,2}$/i.test(thisThemeColor[param])) {
                // valid hex color
                return thisThemeColor[param];
            }
            console.error("themeColor." + param + " need to be valid hex color code");
            return tempColor[param];
        }
        return tempColor[param];
    };
    var setButtonColor = function (param) {
        var tempColor = {
            buttonText: '#fff',
            button: '#961c1c',
            scrollBar: 'darkgrey',
        };
        if (thisThemeColor && thisThemeColor[param]) {
            if (/^#([0-9A-F]{3}){1,2}$/i.test(thisThemeColor[param])) {
                // valid hex color
                return thisThemeColor[param];
            }
            console.error("themeColor." + param + " need to be valid hex color code");
            return tempColor[param];
        }
        return tempColor[param];
    };
    var reminderContent = function (param) {
        var tempBtn = {
            firstTxt: 'First One',
            lastTxt: 'Last One',
        };
        if (thisReminder && thisReminder[param]) {
            return thisReminder[param];
        }
        return tempBtn[param];
    };
    var setDivMinWidth = function () {
        if (thisIsDivElement) {
            if (thisDivElementMinWidth) {
                return thisDivElementMinWidth;
            }
            else {
                console.error('Div Elements must have minWidth');
                return undefined;
            }
        }
        else {
            return undefined;
        }
    };
    if (thisUrlArray[0].url) {
        return (react_1.default.createElement(CarouselQueue_style_1.Styled.Container, { onMouseEnter: function () { return mouseEnterHandler(); }, onMouseLeave: function () { return mouseLeaveHandler(); }, ref: containerRef },
            (thisButtonText === null || thisButtonText === void 0 ? void 0 : thisButtonText.showButton) ? (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(Button_style_1.Button.Prev, { ref: prevButtonRef, imageButton: (thisButtonText === null || thisButtonText === void 0 ? void 0 : thisButtonText.isImageBg) ? thisButtonText.isImageBg : false, colorTxt: setButtonColor('buttonText'), colorBg: setButtonColor('button'), buttonWidth: thisButtonText ? thisButtonText.buttonWidth : 20, buttonHeight: thisButtonText ? thisButtonText.buttonHeight : 100 }, buttonContent('prev')),
                react_1.default.createElement(Button_style_1.Button.Next, { ref: nextButtonRef, imageButton: (thisButtonText === null || thisButtonText === void 0 ? void 0 : thisButtonText.isImageBg) ? thisButtonText.isImageBg : false, colorTxt: setButtonColor('buttonText'), colorBg: setButtonColor('button'), buttonWidth: thisButtonText ? thisButtonText.buttonWidth : 20, buttonHeight: thisButtonText ? thisButtonText.buttonHeight : 100 }, buttonContent('next')))) : (react_1.default.createElement(react_1.default.Fragment, null)),
            (thisReminder === null || thisReminder === void 0 ? void 0 : thisReminder.showReminder) ? (react_1.default.createElement(CarouselQueue_style_1.Styled.ImagesHolderBefore, { ref: imagesHolderBeforeRef, gap: thisGap, show: imageHolderBeforeVisibility, color: setColor('reminderTxt'), colorBg: setColor('reminder') }, reminderContent('firstTxt'))) : (react_1.default.createElement(react_1.default.Fragment, null)),
            react_1.default.createElement(CarouselQueue_style_1.Styled.ImagesHolder, { ref: imagesHolderRef, gap: thisGap }, thisUrlArray.map(function (x, index) {
                // console.dir(callbackRefsArray?.[index]?.toString());
                return (react_1.default.createElement(SingleElement_1.default, { isDivElement: thisIsDivElement, isImageElement: true, isVideoElement: x.isVideo ? x.isVideo : false, minWidth: x.isVideo ? 400 : 0, isFullWidthElement: false, url: x.url, link: x.link, imgAlt: "", gap: thisGap || 0, height: thisComponentHeight, roundCorner: thisRoundCorner || 0, key: index, _ref: callbackRefsArray[index] }));
            })),
            (thisReminder === null || thisReminder === void 0 ? void 0 : thisReminder.showReminder) ? (react_1.default.createElement(CarouselQueue_style_1.Styled.ImagesHolderAfter, { ref: imagesHolderAfterRef, gap: thisGap, show: imageHolderAfterVisibility, color: setColor('reminderTxt'), colorBg: setColor('reminder') }, reminderContent('lastTxt'))) : (react_1.default.createElement(react_1.default.Fragment, null))));
    }
    return (react_1.default.createElement(CarouselQueue_style_1.Styled.Container, { onMouseEnter: function () { return mouseEnterHandler(); }, onMouseLeave: function () { return mouseLeaveHandler(); }, ref: containerRef },
        (thisButtonText === null || thisButtonText === void 0 ? void 0 : thisButtonText.showButton) ? (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(Button_style_1.Button.Prev, { ref: prevButtonRef, imageButton: (thisButtonText === null || thisButtonText === void 0 ? void 0 : thisButtonText.isImageBg) ? thisButtonText.isImageBg : false, colorTxt: setButtonColor('buttonText'), colorBg: setButtonColor('button'), buttonWidth: thisButtonText ? thisButtonText.buttonWidth : 20, buttonHeight: thisButtonText ? thisButtonText.buttonHeight : 100 }, buttonContent('prev')),
            react_1.default.createElement(Button_style_1.Button.Next, { ref: nextButtonRef, imageButton: (thisButtonText === null || thisButtonText === void 0 ? void 0 : thisButtonText.isImageBg) ? thisButtonText.isImageBg : false, colorTxt: setButtonColor('buttonText'), colorBg: setButtonColor('button'), buttonWidth: thisButtonText ? thisButtonText.buttonWidth : 20, buttonHeight: thisButtonText ? thisButtonText.buttonHeight : 100 }, buttonContent('next')))) : (react_1.default.createElement(react_1.default.Fragment, null)),
        (thisReminder === null || thisReminder === void 0 ? void 0 : thisReminder.showReminder) ? (react_1.default.createElement(CarouselQueue_style_1.Styled.ImagesHolderBefore, { ref: imagesHolderBeforeRef, gap: thisGap, show: imageHolderBeforeVisibility, color: setColor('reminderTxt'), colorBg: setColor('reminder') }, reminderContent('firstTxt'))) : (react_1.default.createElement(react_1.default.Fragment, null)),
        react_1.default.createElement(CarouselQueue_style_1.Styled.ImagesHolder, { ref: imagesHolderRef, gap: thisGap }, thisIsDivElement && thisChildren
            ? react_1.default.Children.map(thisChildren, function (child, index) {
                return (react_1.default.createElement(SingleElement_1.default, { isDivElement: thisIsDivElement, key: index, isImageElement: false, isFullWidthElement: false, gap: thisGap || 0, height: thisComponentHeight, minWidth: setDivMinWidth(), roundCorner: thisRoundCorner || 0, _ref: callbackRefsArray[index] }, child));
            })
            : 'Please set thisUrlArray or children'),
        (thisReminder === null || thisReminder === void 0 ? void 0 : thisReminder.showReminder) ? (react_1.default.createElement(CarouselQueue_style_1.Styled.ImagesHolderAfter, { ref: imagesHolderAfterRef, gap: thisGap, show: imageHolderAfterVisibility, color: setColor('reminderTxt'), colorBg: setColor('reminder') }, reminderContent('lastTxt'))) : (react_1.default.createElement(react_1.default.Fragment, null))));
};
exports.default = CarouselQueue;
//# sourceMappingURL=CarouselQueue.js.map