"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDebouncedEffect = void 0;
// https://stackoverflow.com/questions/54666401/how-to-use-throttle-or-debounce-with-react-hook/54666498
var react_1 = require("react");
var useDebouncedEffect = function (effect, delay, deps) {
    var callback = react_1.useCallback(effect, deps);
    react_1.useEffect(function () {
        var handler = setTimeout(function () {
            callback();
        }, delay);
        return function () {
            clearTimeout(handler);
        };
    }, [callback, delay]);
};
exports.useDebouncedEffect = useDebouncedEffect;
//# sourceMappingURL=useDebouncedEffect.js.map